﻿using System;
using System.Collections.Generic;
using System.Linq;

namespace hianyzok
{
    class Naploelem
    {
        public int Honap { get; set; }
        public int Nap { get; set; }
        public string Nev { get; set; }
        public string Jelenlet { get; set; }

        public Naploelem(int ho, int nap, string[] adatok)
        {
            Honap = ho;
            Nap = nap;
            Nev = adatok[0] + " " + adatok[1];
            Jelenlet = adatok[2];
        }

        public int TipusDb(char tipus)
        {
            int db = 0;
            for (int i = 0; i < Jelenlet.Length; i++)
                if (Jelenlet[i] == tipus)
                    db++;
            return db;
        }
    }


    class Program
    {
        static List<Naploelem> naplo = new List<Naploelem>();

        static void Main(string[] args)
        {
            Beolvasas();
            Console.WriteLine("2.feladat");
            Console.WriteLine("A naplóban {0} bejegyzés van.",naplo.Count());
            Console.WriteLine("3.feladat");
            Console.WriteLine("Az igazolt hiányzások száma {0}, az igazolatlanoké {1} óra.", Hianyszum('X'), Hianyszum('I'));
            Console.WriteLine("5.feladat");
            Console.Write("A hónap sorszáma = ");
            int honap = int.Parse(Console.ReadLine());
            Console.Write("A nap sorszáma = ");
            int nap = int.Parse(Console.ReadLine());
            Console.WriteLine("Azon a napon {0} volt.", Hetnapja(honap, nap));
            Console.WriteLine("6.feladat");
            Console.Write("A nap neve = ");
            string napnev = Console.ReadLine();
            Console.Write("Az óra sorszáma = ");
            int ora = int.Parse(Console.ReadLine());
            Console.WriteLine("Ekkor összesen {0} óra hiányzás történt.",LogasDb(napnev, ora));
            Console.WriteLine("7.feladat");
            MaxHianyzok();
            Console.ReadLine();
            
        }

        private static void MaxHianyzok()
        {
            Dictionary<string, int> stat = new Dictionary<string, int>();
            foreach (Naploelem n in naplo)
            {
                if (stat.ContainsKey(n.Nev))
                    stat[n.Nev] += n.TipusDb('X') + n.TipusDb('I');
                else
                    stat.Add(n.Nev, n.TipusDb('X') + n.TipusDb('I'));
            }

            int max = -1;
            foreach (var s in stat)
                if (s.Value > max)
                    max = s.Value;
            Console.Write("A legtöbbet hiányzó tanulók:");
            foreach (var s in stat)
                if(s.Value == max)
                Console.Write(" " + s.Key);
        }

        private static int LogasDb(string napnev, int ora)
        {
            int db = 0;
            foreach (Naploelem n in naplo)
            {
                if (napnev == Hetnapja(n.Honap, n.Nap) && (n.Jelenlet[ora - 1] == 'X' || n.Jelenlet[ora - 1] == 'I'))
                    db++;
            }
            return db;
        }

        private static string Hetnapja(int ho, int nap)
        {
            string[] napnev = { "vasarnap", "hetfo", "kedd", "szerda", "csutortok", "pentek", "szombat" };
            int[] napszam = { 0, 31, 59, 90, 120, 151, 181, 212, 243, 273, 304, 335 };
            return napnev[(napszam[ho - 1] + nap) % 7];
        }

        private static int Hianyszum(char tipus)
        {
            int db = 0;
            foreach (Naploelem n in naplo)
                db += n.TipusDb(tipus);
            return db;
        }

        private static void Beolvasas()
        {
            using (System.IO.StreamReader sr = new System.IO.StreamReader("naplo.txt"))
            {
                int honap = 0; ;
                int nap = 0;
                while (!sr.EndOfStream)
                {
                    string[] adatsor = sr.ReadLine().Split(' ');
                    if (adatsor[0] == "#")
                    {
                        honap = int.Parse(adatsor[1]);
                        nap = int.Parse(adatsor[2]);
                    }
                    else
                    {
                        naplo.Add(new Naploelem(honap, nap, adatsor));
                    }
                }
            }
        }
    }
}
